#! /bin/sh
# iproute2 version, default updown script
#
# Copyright (C) 2003-2004 Nigel Meteringham
# Copyright (C) 2003-2004 Tuomo Soini
# Copyright (C) 2002-2004 Michael Richardson
# Copyright (C) 2005-2006 Andreas Steffen <andreas.steffen@strongswan.org>
# Copyright (C) 2007 Kevin Cody Jr <kcody@vegaresearch.com>
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# RCSID $Id: _updown.in,v 1.2 2006/04/17 15:06:29 as Exp $

# CAUTION:  Installing a new version of strongSwan will install a new
# copy of this script, wiping out any custom changes you make.  If
# you need changes, make a copy of this under another name, and customize
# that, and use the (left/right)updown parameters in ipsec.conf to make
# strongSwan use yours instead of this default one.

# things that this script gets (from ipsec_pluto(8) man page)
#
#      PLUTO_VERSION
#              indicates  what  version of this interface is being
#              used.  This document describes version  1.1.   This
#              is upwardly compatible with version 1.0.
#
#       PLUTO_VERB
#              specifies the name of the operation to be performed
#              (prepare-host, prepare-client, up-host, up-client,
#              down-host, or down-client).  If the address family
#              for security gateway to security gateway communica
#              tions is IPv6, then a suffix of -v6 is added to the
#              verb.
#
#       PLUTO_CONNECTION
#              is the name of the  connection  for  which  we  are
#              routing.
#
#       PLUTO_NEXT_HOP
#              is the next hop to which packets bound for the peer
#              must be sent.
#
#       PLUTO_INTERFACE
#              is the name of the ipsec interface to be used.
#
#       PLUTO_REQID
#              is the requid of the ESP policy
#
#       PLUTO_ME
#              is the IP address of our host.
#
#       PLUTO_MY_ID
#              is the ID of our host.
#
#       PLUTO_MY_CLIENT
#              is the IP address / count of our client subnet.  If
#              the  client  is  just  the  host,  this will be the
#              host's own IP address / max (where max  is  32  for
#              IPv4 and 128 for IPv6).
#
#       PLUTO_MY_CLIENT_NET
#              is the IP address of our client net.  If the client
#              is just the host, this will be the  host's  own  IP
#              address.
#
#       PLUTO_MY_CLIENT_MASK
#              is  the  mask for our client net.  If the client is
#              just the host, this will be 255.255.255.255.
#
#       PLUTO_MY_SOURCEIP
#              if non-empty, then the source address for the route will be
#              set to this IP address.
#
#       PLUTO_MY_PROTOCOL
#              is the IP protocol that will be transported.
#
#       PLUTO_MY_PORT
#              is  the  UDP/TCP  port  to  which  the IPsec SA  is
#              restricted on our side.
#
#       PLUTO_PEER
#              is the IP address of our peer.
#
#       PLUTO_PEER_ID
#              is the ID of our peer.
#
#       PLUTO_PEER_CA
#              is the CA which issued the cert of our peer.
#
#       PLUTO_PEER_CLIENT
#              is the IP address / count of the peer's client sub
#              net.   If the client is just the peer, this will be
#              the peer's own IP address / max (where  max  is  32
#              for IPv4 and 128 for IPv6).
#
#       PLUTO_PEER_CLIENT_NET
#              is the IP address of the peer's client net.  If the
#              client is just the peer, this will  be  the  peer's
#              own IP address.
#
#       PLUTO_PEER_CLIENT_MASK
#              is  the  mask  for  the  peer's client net.  If the
#              client   is   just   the   peer,   this   will   be
#              255.255.255.255.
#
#       PLUTO_PEER_PROTOCOL
#              is the IP protocol that will be transported.
#
#       PLUTO_PEER_PORT
#              is  the  UDP/TCP  port  to  which  the IPsec SA  is
#              restricted on the peer side.
#

# set to /bin/true to silence log messages
LOGGER=logger

# tag put in front of each log entry:
TAG=vpn

# syslog facility and priority used:
FAC_PRIO=authpriv.info


# in the presence of KLIPS and ipsecN interfaces do not use IPSEC_POLICY 
if [ `echo "$PLUTO_INTERFACE" | grep "ipsec"` ] ; then
	IPSEC_POLICY_IN=""
	IPSEC_POLICY_OUT=""
else
	IPSEC_POLICY="-m policy --pol ipsec --proto esp --reqid $PLUTO_REQID"
	IPSEC_POLICY_IN="$IPSEC_POLICY --dir in"
	IPSEC_POLICY_OUT="$IPSEC_POLICY --dir out"
fi

# are there port numbers?
if [ "$PLUTO_MY_PORT" != 0 ] ; then
	S_MY_PORT="--sport $PLUTO_MY_PORT"
	D_MY_PORT="--dport $PLUTO_MY_PORT"
fi

if [ "$PLUTO_PEER_PORT" != 0 ] ; then
	S_PEER_PORT="--sport $PLUTO_PEER_PORT"
	D_PEER_PORT="--dport $PLUTO_PEER_PORT"
fi

# import firewall behavior
IPT_RULE_IN=$IPSEC_UPDOWN_RULE_IN
IPT_DEST_IN=$IPSEC_UPDOWN_DEST_IN
IPT_RULE_OUT=$IPSEC_UPDOWN_RULE_OUT
IPT_DEST_OUT=$IPSEC_UPDOWN_DEST_OUT

# import forwarding behavior
FWD_RULE_IN=$IPSEC_UPDOWN_FWD_RULE_IN
FWD_DEST_IN=$IPSEC_UPDOWN_FWD_DEST_IN
FWD_RULE_OUT=$IPSEC_UPDOWN_FWD_RULE_OUT
FWD_DEST_OUT=$IPSEC_UPDOWN_FWD_DEST_OUT

# default firewall behavior
[ -z "$IPT_RULE_IN"  ] && IPT_RULE_IN=INPUT
[ -z "$IPT_DEST_IN"  ] && IPT_DEST_IN=ACCEPT
[ -z "$IPT_RULE_OUT" ] && IPT_RULE_OUT=OUTPUT
[ -z "$IPT_DEST_OUT" ] && IPT_DEST_OUT=ACCEPT

# default forwarding behavior
[ -z "$FWD_RULE_IN"  ] && FWD_RULE_IN=FORWARD
[ -z "$FWD_DEST_IN"  ] && FWD_DEST_IN=ACCEPT
[ -z "$FWD_RULE_OUT" ] && FWD_RULE_OUT=FORWARD
[ -z "$FWD_DEST_OUT" ] && FWD_DEST_OUT=ACCEPT


# check interface version
case "$PLUTO_VERSION" in
1.[0|1])	# Older Pluto?!?  Play it safe, script may be using new features.
	echo "$0: obsolete interface version \`$PLUTO_VERSION'," >&2
	echo "$0: 	called by obsolete Pluto?" >&2
	exit 2
	;;
1.*)	;;
*)	echo "$0: unknown interface version \`$PLUTO_VERSION'" >&2
	exit 2
	;;
esac

# check parameter(s)
case "$1:$*" in
':')			# no parameters
	;;
custom:*)		# custom parameters (see above CAUTION comment)
	;;
*)	echo "$0: unknown parameters \`$*'" >&2
	exit 2
	;;
esac


# utility functions for route manipulation
# Meddling with this stuff should not be necessary and requires great care.

uproute() {
	doroute add
	ip route flush cache
}

downroute() {
	doroute delete
	ip route flush cache
}

upfirewall() {
	in_rule=$1
	in_dest=$2
	out_rule=$3
	out_dest=$4

	[ -n "$in_rule" -a -n "$in_dest" ] &&		\
	iptables -I $in_rule 1				\
		-i $PLUTO_INTERFACE			\
		-p $PLUTO_MY_PROTOCOL			\
		-s $PLUTO_PEER_CLIENT	$S_PEER_PORT	\
		-d $PLUTO_MY_CLIENT	$D_MY_PORT	\
		$IPSEC_POLICY_IN			\
		-j $in_dest

	[ -n "$out_rule" -a -n "$out_dest" ] &&		\
	iptables -I $out_rule 1				\
		-o $PLUTO_INTERFACE			\
		-p $PLUTO_PEER_PROTOCOL			\
		-s $PLUTO_MY_CLIENT	$S_MY_PORT	\
		-d $PLUTO_PEER_CLIENT	$D_PEER_PORT	\
		$IPSEC_POLICY_OUT			\
		-j $out_dest

}

downfirewall() {
	in_rule=$1
	in_dest=$2
	out_rule=$3
	out_dest=$4

	[ -n "$in_rule" -a -n "$in_dest" ] &&		\
	iptables -D $in_rule				\
		-i $PLUTO_INTERFACE			\
		-p $PLUTO_MY_PROTOCOL			\
		-s $PLUTO_PEER_CLIENT	$S_PEER_PORT	\
		-d $PLUTO_MY_CLIENT	$D_MY_PORT	\
		$IPSEC_POLICY_IN			\
		-j $in_dest

	[ -n "$out_rule" -a -n "$out_dest" ] &&		\
	iptables -D $out_rule				\
		-o $PLUTO_INTERFACE			\
		-p $PLUTO_PEER_PROTOCOL			\
		-s $PLUTO_MY_CLIENT	$S_MY_PORT	\
		-d $PLUTO_PEER_CLIENT	$D_PEER_PORT	\
		$IPSEC_POLICY_OUT			\
		-j $out_dest

}

addsource() {
	st=0

	if ! ip -o route get ${PLUTO_MY_SOURCEIP%/*} | grep -q ^local ; then

	    it="ip addr add ${PLUTO_MY_SOURCEIP%/*}/32 dev $PLUTO_INTERFACE"
	    oops="`eval $it 2>&1`"
	    st=$?

	    if [ " $oops"  = " " -a " $st" != " 0" ] ; then
		oops="silent error, exit status $st"
	    fi

	    if [ " $oops" != " " -o " $st" != " 0" ] ; then
		echo "$0: addsource \`$it' failed ($oops)" >&2
	    fi
	fi

	return $st
}

doroute() {
	st=0
	parms="$PLUTO_PEER_CLIENT"
	parms2="dev $PLUTO_INTERFACE"

	if [ -z "$PLUTO_MY_SOURCEIP" ] ; then

		[ -f /etc/sysconfig/defaultsource ] && \
			. /etc/sysconfig/defaultsource

		[ -f /etc/conf.d/defaultsource ] && \
			. /etc/conf.d/defaultsource

	    	[ -n "$DEFAULTSOURCE" ]	&& \
			PLUTO_MY_SOURCEIP=$DEFAULTSOURCE

        fi

	parms3=
	if [ "$1" = "add" -a -n "$PLUTO_MY_SOURCEIP" ] ; then
	    addsource
	    parms3="$parms3 src ${PLUTO_MY_SOURCEIP%/*}"
	fi

	if [ "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" = \
						"0.0.0.0/0.0.0.0" ] ; then
		# opportunistic encryption work around
		# need to provide route that eclipses default, without 
		# replacing it.
		it="ip route $1   0.0.0.0/1 $parms2 $parms3 &&
		    ip route $1 128.0.0.0/1 $parms2 $parms3"
	else
		it="ip route $1 $parms $parms2 $parms3"
	fi

	oops="`eval $it 2>&1`"
	st=$?

	if [ " $oops" = " " -a " $st" != " 0" ] ; then
		oops="silent error, exit status $st"
	fi

	if [ " $oops" != " " -o " $st" != " 0" ] ; then
		echo "$0: doroute \`$it' failed ($oops)" >&2
	fi

	return $st
}

dologentry() {
	action=$1

	if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ] ; then
		rem="$PLUTO_PEER"
	else
		rem="$PLUTO_PEER_CLIENT == $PLUTO_PEER"
	fi

	if [ "$PLUTO_MY_CLIENT" == "$PLUTO_ME/32" ] ; then
		loc="$PLUTO_ME"
	else
		loc="$PLUTO_ME == $PLUTO_MY_CLIENT"
	fi

	$LOGGER -t $TAG -p $FAC_PRIO "$action $rem -- $loc ($PLUTO_PEER_ID)"
}


# the big choice

case "$PLUTO_VERB:$1" in
prepare-host:*|prepare-client:*)
	# delete possibly-existing route (preliminary to adding a route)

	if [ "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" = \
						"0.0.0.0/0.0.0.0" ] ; then
		# need to remove the route that eclipses default, without 
		# replacing it.
		it="( ip route delete   0.0.0.0/1 ;
		      ip route delete 128.0.0.0/1 )"
	else
		it="ip route delete $PLUTO_PEER_CLIENT"
	fi

	oops="`$it 2>&1`"
	st="$?"

	if [ " $oops" = " " -a " $st" != " 0" ] ; then
		oops="silent error, exit status $st"
	fi

	case "$oops" in
	*'RTNETLINK answers: No such process'*)	
		# This is what route (currently -- not documented!) gives
		# for "could not find such a route".
		oops=
		st=0
		;;
	esac

	if [ " $oops" != " " -o " $st" != " 0" ] ; then
		echo "$0: \`$it' failed ($oops)" >&2
	fi

	exit $st

	;;
route-host:*|route-client:*)
	# connection to me or my client subnet being routed

	ipsec _showstatus valid
	uproute

	;;
unroute-host:*|unroute-client:*)
	# connection to me or my client subnet being unrouted

	ipsec _showstatus invalid
	downroute

	;;
up-host:*)
	# connection to me coming up

	ipsec _showstatus up
	upfirewall $IPT_RULE_IN $IPT_DEST_IN $IPT_RULE_OUT $OUT_DEST_OUT
	dologentry "VPN-UP"

	;;
down-host:*)
	# connection to me going down

	ipsec _showstatus down
	downfirewall $IPT_RULE_IN $IPT_DEST_IN $IPT_RULE_OUT $OUT_DEST_OUT
	dologentry "VPN-DN"

	;;
up-client:*)
	# connection to client subnet coming up

	ipsec _showstatus up

	if [ "$PLUTO_MY_CLIENT" != "$PLUTO_ME/32" -a \
	     "$PLUTO_MY_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ] ; then
		upfirewall $FWD_RULE_IN $FWD_DEST_IN $FWD_RULE_OUT $FWD_DEST_OUT
	fi

	# a virtual IP requires an INPUT and OUTPUT rule on the host
	# or sometimes host access via the internal IP is needed
	if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ] ; then
		upfirewall $IPT_RULE_IN $IPT_DEST_IN $IPT_RULE_OUT $OUT_DEST_OUT
	fi

	dologentry "VPN-UP"

	;;
down-client:*)
	# connection to client subnet going down

	ipsec _showstatus down

	if [ "$PLUTO_MY_CLIENT" != "$PLUTO_ME/32" -a \
	     "$PLUTO_MY_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ] ; then
		downfirewall $FWD_RULE_IN $FWD_DEST_IN $FWD_RULE_OUT $FWD_DEST_OUT
	fi

	# a virtual IP requires an INPUT and OUTPUT rule on the host
	# or sometimes host access via the internal IP is needed
	if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ] ; then
		downfirewall $IPT_RULE_IN $IPT_DEST_IN $IPT_RULE_OUT $OUT_DEST_OUT
	fi

	dologentry "VPN-DN"

	;;
prepare-host-v6:*|prepare-client-v6:*)

	;;
route-host-v6:*|route-client-v6:*)
	# connection to me or my client subnet being routed

	#uproute_v6

	;;
unroute-host-v6:*|unroute-client-v6:*)
	# connection to me or my client subnet being unrouted

	#downroute_v6

	;;
up-host-v6:*)
	# connection to me coming up
	# If you are doing a custom version, firewall commands go here.

	;;
down-host-v6:*)
	# connection to me going down
	# If you are doing a custom version, firewall commands go here.

	;;
up-client-v6:)
	# connection to my client subnet coming up
	# If you are doing a custom version, firewall commands go here.

	;;
down-client-v6:)
	# connection to my client subnet going down
	# If you are doing a custom version, firewall commands go here.

	;;
*)
	echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
	exit 1

	;;
esac

